@use 'sass:math';

:host {
  display: grid;
  place-items: center;
  grid-auto-flow: column;
  grid-auto-columns: 1fr;
}

.custom-background,
.custom-background-1 {
  display: inline-block;
  width: 100px;
  height: 100px;
}

.custom-background {
  background-color: #2ecc71;
}

.custom-background-1 {
  background-color: #2980b9;
}

.spinner {
  --ui-spinner-size: 100px;
  --ui-spinner-stroke-width: 10;
  --ui-spinner-animation-duration: 1.5s;
  --ui-spinner-stroke-color: #8e44ad;

  position: relative;
  display: inline-block;
  height: var(--ui-spinner-size);
  width: var(--ui-spinner-size);

  $base-radius: 50;
  $offset: $base-radius * 2 * math.$pi;

  svg {
    position: absolute;
    inset: 0;
    width: var(--ui-spinner-size);
    height: var(--ui-spinner-size);
    animation: rotate var(--ui-spinner-animation-duration) linear infinite;

    @keyframes rotate {
      0% {
        transform: rotate(0deg);
      }
      100% {
        transform: rotate(270deg);
      }
    }

    circle {
      fill: none;
      stroke-width: var(--ui-spinner-stroke-width);
      stroke: var(--ui-spinner-stroke-color);
      stroke-linecap: round;

      stroke-dasharray: $offset;
      stroke-dashoffset: 0;
      transform-origin: center;
      animation: stroke-dash var(--ui-spinner-animation-duration) ease-in-out infinite;

      @keyframes stroke-dash {
        0% {
          stroke-dashoffset: $offset;
        }
        50% {
          stroke-dashoffset: math.div($offset, 4);
          transform: rotate(135deg);
        }
        100% {
          stroke-dashoffset: $offset;
          transform: rotate(450deg);
        }
      }
    }
  }
}
